
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Web服务精讲–搭个 Web 服务器（二） / 憋错料</title>

    <meta name="description" content="Web服务精讲–搭个 Web 服务器（二） 导读 曾几何时,你所选择的 Python Web 框架会限制你所可选择的 Web 服务器,反之亦然.如果某个框架及服务器设计用来协同工作的,那么一切正常. 在第一部分中,我提出了一个问题:“如何在你刚刚搭建起来的 Web 服务器上适配 Django, Flask 或 Pyramid 应用,而不用单独对 Web 服务器做做出改动以适应各种不同的 Web 框架呢?”我们可以从这一篇中找到答案. 但你可能正面对着(或者曾经面对过)尝试将一对无法适配的框架和服务器搭配在一起的问题: 基本上,你需要选择那">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Web服务精讲–搭个 Web 服务器（二）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<table>
<tbody>
<tr>
<td>导读</td>
<td><strong>曾几何时，你所选择的 Python Web 框架会限制你所可选择的 Web 服务器，反之亦然。如果某个框架及服务器设计用来协同工作的，那么一切正常。</strong></td>
</tr>
</tbody>
</table>
<p>在第一部分中，我提出了一个问题：&ldquo;如何在你刚刚搭建起来的 Web 服务器上适配 Django, Flask 或 Pyramid 应用，而不用单独对 Web 服务器做做出改动以适应各种不同的 Web 框架呢？&rdquo;我们可以从这一篇中找到答案。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwMG9qdzQ5dW1oZHBuNGFld28ucG5n.jpg" /></p>
<p>但你可能正面对着（或者曾经面对过）尝试将一对无法适配的框架和服务器搭配在一起的问题：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwMWo5YXY3eTl5d3hhMDV4NWkucG5n.jpg" /></p>
<p>基本上，你需要选择那些能够一起工作的框架和服务器，而不能选择你想用的那些。</p>
<p>所以，你该如何确保在不对 Web 服务器或框架的代码做任何更改的情况下，让你的 Web 服务器和多个不同的 Web 框架一同工作呢？这个问题的答案，就是 Python Web 服务器网关接口（Web Server Gateway Interface ）（缩写为 WSGI，念做&ldquo;wizgy&rdquo;）。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwMnZodWI5d2h0OWU4Y2JlaXoucG5n.jpg" /></p>
<p>WSGI 允许开发者互不干扰地选择 Web 框架及 Web 服务器的类型。现在，你可以真正将 Web 服务器及框架任意搭配，然后选出你最中意的那对组合。比如，你可以使用 <strong>Django</strong>，<strong>Flask </strong>或者 <strong>Pyramid</strong>，与 <strong>Gunicorn</strong>，<strong>Nginx/uWSGI </strong>或 <strong>Waitress</strong> 进行结合。感谢 WSGI 同时对服务器与框架的支持，我们可以真正随意选择它们的搭配了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwNHdwbGVyNG80cHZsZXpycm8ucG5n.jpg" /></p>
<p>所以，WSGI 就是我在第一部分中提出，又在本文开头重复了一遍的那个问题的答案。你的 Web 服务器必须实现 WSGI 接口的服务器部分，而现代的 Python Web 框架均已实现了 WSGI 接口的框架部分，这使得你可以直接在 Web 服务器中使用任意框架，而不需要更改任何服务器代码，以对特定的 Web 框架实现兼容。</p>
<p>现在，你已经知道 Web 服务器及 Web 框架对 WSGI 的支持使得你可以选择最合适的一对来使用，而且它也有利于服务器和框架的开发者，这样他们只需专注于其擅长的部分来进行开发，而不需要触及另一部分的代码。其它语言也拥有类似的接口，比如：Java 拥有 Servlet API，而 Ruby 拥有 Rack。</p>
<p>这些理论都不错，但是我打赌你在说：&ldquo;Show me the code!&rdquo; 那好，我们来看看下面这个很小的 WSGI 服务器实现：</p>
<pre>### 使用 Python 2.7.9，在 Linux 及 Mac OS X 下测试通过
import socket
import StringIO
import sys

class WSGIServer(object):

    address_family = socket.AF_INET
    socket_type = socket.SOCK_STREAM
    request_queue_size = 1

    def __init__(self, server_address):
        ### 创建一个监听的套接字
        self.listen_socket = listen_socket = socket.socket(
            self.address_family,
            self.socket_type
        )
        ### 允许复用同一地址
        listen_socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        ### 绑定地址
        listen_socket.bind(server_address)
        ### 激活套接字
        listen_socket.listen(self.request_queue_size)
        ### 获取主机的名称及端口
        host, port = self.listen_socket.getsockname()[:2]
        self.server_name = socket.getfqdn(host)
        self.server_port = port
        ### 返回由 Web 框架/应用设定的响应头部字段
        self.headers_set = []

    def set_app(self, application):
        self.application = application

    def serve_forever(self):
        listen_socket = self.listen_socket
        while True:
            ### 获取新的客户端连接
            self.client_connection, client_address = listen_socket.accept()
            ### 处理一条请求后关闭连接，然后循环等待另一个连接建立
            self.handle_one_request()

    def handle_one_request(self):
        self.request_data = request_data = self.client_connection.recv(1024)
        ### 以 ‘curl -v‘ 的风格输出格式化请求数据
        print(‘‘.join(
            ‘&lt; {line}/n‘.format(line=line)
            for line in request_data.splitlines()
        ))

        self.parse_request(request_data)

        ### 根据请求数据构建环境变量字典
        env = self.get_environ()

        ### 此时需要调用 Web 应用来获取结果，
        ### 取回的结果将成为 HTTP 响应体
        result = self.application(env, self.start_response)

        ### 构造一个响应，回送至客户端
        self.finish_response(result)

    def parse_request(self, text):
        request_line = text.splitlines()[0]
        request_line = request_line.rstrip(‘/r/n‘)
        ### 将请求行分成几个部分
        (self.request_method,  # GET
         self.path,            # /hello
         self.request_version  # HTTP/1.1
         ) = request_line.split()

    def get_environ(self):
        env = {}
        ### 以下代码段没有遵循 PEP8 规则，但这样排版，是为了通过强调
        ### 所需变量及它们的值，来达到其展示目的。
        ###
        ### WSGI 必需变量
        env[‘wsgi.version‘]      = (1, 0)
        env[‘wsgi.url_scheme‘]   = ‘http‘
        env[‘wsgi.input‘]        = StringIO.StringIO(self.request_data)
        env[‘wsgi.errors‘]       = sys.stderr
        env[‘wsgi.multithread‘]  = False
        env[‘wsgi.multiprocess‘] = False
        env[‘wsgi.run_once‘]     = False
        ### CGI 必需变量
        env[‘REQUEST_METHOD‘]    = self.request_method    # GET
        env[‘PATH_INFO‘]         = self.path              # /hello
        env[‘SERVER_NAME‘]       = self.server_name       # localhost
        env[‘SERVER_PORT‘]       = str(self.server_port)  # 8888
        return env

    def start_response(self, status, response_headers, exc_info=None):
        ### 添加必要的服务器头部字段
        server_headers = [
            (‘Date‘, ‘Tue, 31 Mar 2015 12:54:48 GMT‘),
            (‘Server‘, ‘WSGIServer 0.2‘),
        ]
        self.headers_set = [status, response_headers + server_headers]
        ### 为了遵循 WSGI 协议，start_response 函数必须返回一个 ‘write‘
        ### 可调用对象（返回值.write 可以作为函数调用）。为了简便，我们
        ### 在这里无视这个细节。
        ### return self.finish_response

    def finish_response(self, result):
        try:
            status, response_headers = self.headers_set
            response = ‘HTTP/1.1 {status}/r/n‘.format(status=status)
            for header in response_headers:
                response += ‘{0}: {1}/r/n‘.format(*header)
            response += ‘/r/n‘
            for data in result:
                response += data
            ### 以 ‘curl -v‘ 的风格输出格式化请求数据
            print(‘‘.join(
                ‘&gt; {line}/n‘.format(line=line)
                for line in response.splitlines()
            ))
            self.client_connection.sendall(response)
        finally:
            self.client_connection.close()

SERVER_ADDRESS = (HOST, PORT) = ‘‘, 8888

def make_server(server_address, application):
    server = WSGIServer(server_address)
    server.set_app(application)
    return server

if __name__ == ‘__main__‘:
    if len(sys.argv) &lt; 2:
        sys.exit(‘Provide a WSGI application object as module:callable‘)
    app_path = sys.argv[1]
    module, application = app_path.split(‘:‘)
    module = __import__(module)
    application = getattr(module, application)
    httpd = make_server(SERVER_ADDRESS, application)
    print(‘WSGIServer: Serving HTTP on port {port} .../n‘.format(port=PORT))
    httpd.serve_forever()
</pre>
<p>当然，这段代码要比第一部分的服务器代码长不少，但它仍然很短（只有不到 150 行），你可以轻松理解它，而不需要深究细节。上面的服务器代码还可以做更多&mdash;&mdash;它可以用来运行一些你喜欢的框架写出的 Web 应用，可以是 Pyramid，Flask，Django 或其它 Python WSGI 框架。</p>
<p>不相信吗？自己来试试看吧。把以上的代码保存为</p>
<pre>webserver2.py</pre>
<p>，或直接从 Github 上下载它。如果你打算不加任何参数而直接运行它，它会抱怨一句，然后退出。</p>
<pre>$ python webserver2.py
Provide a WSGI application object as module:callable
</pre>
<p>它想做的其实是为你的 Web 应用服务，而这才是重头戏。为了运行这个服务器，你唯一需要的就是安装好 Python。不过，如果你希望运行 Pyramid，Flask 或 Django 应用，你还需要先安装那些框架。那我们把这三个都装上吧。我推荐的安装方式是通过 <strong>virtualenv</strong>安装。按照以下几步来做，你就可以创建并激活一个虚拟环境，并在其中安装以上三个 Web 框架。</p>
<pre>$ [sudo] pip install virtualenv
$ mkdir ~/envs
$ virtualenv ~/envs/lsbaws/
$ cd ~/envs/lsbaws/
$ ls
bin  include  lib
$ source bin/activate
(lsbaws) $ pip install pyramid
(lsbaws) $ pip install flask
(lsbaws) $ pip install django
</pre>
<p>现在，你需要创建一个 Web 应用。我们先从 Pyramid 开始吧。把以下代码保存为</p>
<pre>pyramidapp.py</pre>
<p>，并与刚刚的</p>
<pre>webserver2.py</pre>
<p>放置在同一目录，或直接从 Github 下载该文件：</p>
<pre>from pyramid.config import Configurator
from pyramid.response import Response

def hello_world(request):
    return Response(
        ‘Hello world from Pyramid!/n‘,
        content_type=‘text/plain‘,
    )

config = Configurator()
config.add_route(‘hello‘, ‘/hello‘)
config.add_view(hello_world, route_name=‘hello‘)
app = config.make_wsgi_app()
</pre>
<p>现在，你可以用你自己的 Web 服务器来运行你的 Pyramid 应用了：</p>
<pre>(lsbaws) $ python webserver2.py pyramidapp:app
WSGIServer: Serving HTTP on port 8888 ...
</pre>
<p>你刚刚让你的服务器去加载 Python 模块<strong>pyramidapp</strong> 中的可执行对象 <strong>app</strong>。现在你的服务器可以接收请求，并将它们转发到你的 <strong>Pyramid</strong> 应用中了。在浏览器中输入 http://localhost:8888/hello ，敲一下回车，然后看看结果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwNXBzbmE3N2l6bG9vcXQ5czcucG5n.jpg" /></p>
<p>你也可以使用命令行工具 <strong>curl</strong> 来测试服务器：</p>
<pre>$ curl -v http://localhost:8888/hello
...
</pre>
<p>看看服务器和<strong>curl </strong>向标准输出流打印的内容吧。</p>
<p>现在来试试 <strong>Flask</strong>。运行步骤跟上面的一样。</p>
<pre>from flask import Flask
from flask import Response
flask_app = Flask(‘flaskapp‘)

@flask_app.route(‘/hello‘)
def hello_world():
    return Response(
        ‘Hello world from Flask!/n‘,
        mimetype=‘text/plain‘
    )

app = flask_app.wsgi_app
</pre>
<p>将以上代码保存为</p>
<pre>flaskapp.py</pre>
<p>，或者直接从 Github 下载，然后输入以下命令运行服务器：</p>
<pre>(lsbaws) $ python webserver2.py flaskapp:app
WSGIServer: Serving HTTP on port 8888 ...
</pre>
<p>现在在浏览器中输入 http://localhost:8888/hello ，敲一下回车：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwNnQ2OGRpc3ZzN2hwbTZtenkucG5n.jpg" /></p>
<p>同样，尝试一下 <strong>curl</strong>，然后你会看到服务器返回了一条 <strong>Flask</strong> 应用生成的信息：</p>
<pre>$ curl -v http://localhost:8888/hello
...
</pre>
<p>这个服务器能处理 Django 应用吗？试试看吧！不过这个任务可能有点复杂，所以我建议你将整个仓库克隆下来，然后使用 Github 仓库中的 djangoapp.py 来完成这个实验。这里的源代码主要是将 Django 的 helloworld 工程（已使用 Django的</p>
<pre>django-admin.py startproject</pre>
<p>命令创建完毕）添加到了当前的 Python 路径中，然后导入了这个工程的 WSGI 应用。（LCTT 译注：除了这里展示的代码，还需要一个配合的 helloworld 工程才能工作，代码可以参见 Github 仓库。）</p>
<pre>import sys
sys.path.insert(0, ‘./helloworld‘)
from helloworld import wsgi

app = wsgi.application
</pre>
<p>将以上代码保存为</p>
<pre>djangoapp.py</pre>
<p>，然后用你的 Web 服务器运行这个 Django 应用：</p>
<pre>(lsbaws) $ python webserver2.py djangoapp:app
WSGIServer: Serving HTTP on port 8888 ...
</pre>
<p>输入以下链接，敲回车：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwN2M0empnNDRoeGhiYzg0ajQucG5n.jpg" /></p>
<p>你这次也可以在命令行中测试&mdash;&mdash;你之前应该已经做过两次了&mdash;&mdash;来确认 Django 应用处理了你的请求：</p>
<pre>$ curl -v http://localhost:8888/hello
...
</pre>
<p>你试过了吗？你确定这个服务器可以与那三个框架搭配工作吗？如果没试，请去试一下。阅读固然重要，但这个系列的内容是<strong>重新搭建</strong>，这意味着你需要亲自动手干点活。去试一下吧。别担心，我等着你呢。不开玩笑，你真的需要试一下，亲自尝试每一步，并确保它像预期的那样工作。</p>
<p>好，你已经体验到了 WSGI 的威力：它可以使 Web 服务器及 Web 框架随意搭配。WSGI 在 Python Web 服务器及框架之间提供了一个微型接口。它非常简单，而且在服务器和框架端均可以轻易实现。下面的代码片段展示了 WSGI 接口的服务器及框架端实现：</p>
<pre>def run_application(application):
    """服务器端代码。"""
    ### Web 应用/框架在这里存储 HTTP 状态码以及 HTTP 响应头部，
    ### 服务器会将这些信息传递给客户端
    headers_set = []
    ### 用于存储 WSGI/CGI 环境变量的字典
    environ = {}

    def start_response(status, response_headers, exc_info=None):
        headers_set[:] = [status, response_headers]

    ### 服务器唤醒可执行变量&ldquo;application&rdquo;，获得响应头部
    result = application(environ, start_response)
    ### 服务器组装一个 HTTP 响应，将其传送至客户端
    &hellip;

def app(environ, start_response):
    """一个空的 WSGI 应用"""
    start_response(‘200 OK‘, [(‘Content-Type‘, ‘text/plain‘)])
    return [‘Hello world!‘]

run_application(app)
</pre>
<p>这是它的工作原理：</p>
<ol>
<li>Web 框架提供一个可调用对象 <strong>application </strong>（WSGI 规范没有规定它的实现方式）。</li>
<li>Web 服务器每次收到来自客户端的 HTTP 请求后，会唤醒可调用对象 <strong>applition</strong>。它会向该对象传递一个包含 WSGI/CGI 变量的环境变量字典<strong> environ</strong>，以及一个可调用对象 <strong>start_response</strong>。</li>
<li>Web 框架或应用生成 HTTP 状态码和 HTTP 响应头部，然后将它传给 <strong>start_response</strong> 函数，服务器会将其存储起来。同时，Web 框架或应用也会返回 HTTP 响应正文。</li>
<li>服务器将状态码、响应头部及响应正文组装成一个 HTTP 响应，然后将其传送至客户端（这一步并不在 WSGI 规范中，但从逻辑上讲，这一步应该包含在工作流程之中。所以为了明确这个过程，我把它写了出来）</li>
</ol>
<p>这是这个接口规范的图形化表达：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYwOGtxMnFkaWdpdGp1MmRxdmkucG5n.jpg" /></p>
<p>到现在为止，你已经看过了用 Pyramid、Flask 和 Django 写出的 Web 应用的代码，你也看到了一个 Web 服务器如何用代码来实现另一半（服务器端的） WSGI 规范。你甚至还看到了我们如何在不使用任何框架的情况下，使用一段代码来实现一个最简单的 WSGI Web 应用。</p>
<p>其实，当你使用上面的框架编写一个 Web 应用时，你只是在较高的层面工作，而不需要直接与 WSGI 打交道。但是我知道你一定也对 WSGI 接口的框架部分感兴趣，因为你在看这篇文章呀。所以，我们不用 Pyramid、Flask 或 Django，而是自己动手来创造一个最朴素的 WSGI Web 应用（或 Web 框架），然后将它和你的服务器一起运行：</p>
<pre>def app(environ, start_response):
    """一个最简单的 WSGI 应用。

    这是你自己的 Web 框架的起点 ^_^
    """
    status = ‘200 OK‘
    response_headers = [(‘Content-Type‘, ‘text/plain‘)]
    start_response(status, response_headers)
    return [‘Hello world from a simple WSGI application!/n‘]
</pre>
<p>同样，将上面的代码保存为</p>
<pre>wsgiapp.py</pre>
<p>或直接从 Github 上下载该文件，然后在 Web 服务器上运行这个应用，像这样：</p>
<pre>(lsbaws) $ python webserver2.py wsgiapp:app
WSGIServer: Serving HTTP on port 8888 ...
</pre>
<p>在浏览器中输入下面的地址，然后按下回车。这是你应该看到的结果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYxMHJoYWcyZzk5NGZ2OTJ6ZjAucG5n.jpg" /></p>
<p>你刚刚在学习如何创建一个 Web 服务器的过程中自己编写了一个最朴素的 WSGI Web 框架！棒极了！</p>
<p>现在，我们再回来看看服务器传给客户端的那些东西。这是在使用 HTTP 客户端调用你的 Pyramid 应用时，服务器生成的 HTTP 响应内容：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYxMnYzbDN2M2E0Mjc1ajR5MjQucG5n.jpg" /></p>
<p>这个响应和你在本系列第一部分中看到的 HTTP 响应有一部分共同点，但它还多出来了一些内容。比如说，它拥有四个你曾经没见过的 HTTP 头部：<strong>Content-Type</strong>, <strong>Content-Length</strong>, <strong>Date </strong>以及<strong>Server</strong>。这些头部内容基本上在每个 Web 服务器返回的响应中都会出现。不过，它们都不是被严格要求出现的。这些 HTTP 请求/响应头部字段的目的在于它可以向你传递一些关于 HTTP 请求/响应的额外信息。</p>
<p>既然你对 WSGI 接口了解的更深了一些，那我再来展示一下上面那个 HTTP 响应中的各个部分的信息来源：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYxNnBmb29taXFtcmRzd3JwcXoucG5n.jpg" /></p>
<p>我现在还没有对上面那个<strong>environ </strong>字典做任何解释，不过基本上这个字典必须包含那些被 WSGI 规范事先定义好的 WSGI 及 CGI 变量值。服务器在解析 HTTP 请求时，会从请求中获取这些变量的值。这是 <strong>environ</strong> 字典应该有的样子：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYxOGFwdG9nZ2p0dHV6cm92dmcucG5n.jpg" /></p>
<p>Web 框架会利用以上字典中包含的信息，通过字典中的请求路径、请求动作等等来决定使用哪个视图来处理响应、在哪里读取请求正文、在哪里输出错误信息（如果有的话）。</p>
<p>现在，你已经创造了属于你自己的 WSGI Web 服务器，你也使用不同 Web 框架做了几个 Web 应用。而且，你在这个过程中也自己创造出了一个朴素的 Web 应用及框架。这个过程真是累人。现在我们来回顾一下，你的 WSGI Web 服务器在服务请求时，需要针对 WSGI 应用做些什么：</p>
<ul>
<li>首先，服务器开始工作，然后会加载一个可调用对象 <strong>application</strong>，这个对象由你的 Web 框架或应用提供</li>
<li>然后，服务器读取一个请求</li>
<li>然后，服务器会解析这个请求</li>
<li>然后，服务器会使用请求数据来构建一个 <strong>environ</strong> 字典</li>
<li>然后，它会用 <strong>environ</strong> 字典及一个可调用对象 <strong>start_response</strong> 作为参数，来调用 <strong>application</strong>，并获取响应体内容。</li>
<li>然后，服务器会使用 <strong>application</strong>返回的响应体，和 <strong>start_response</strong> 函数设置的状态码及响应头部内容，来构建一个 HTTP 响应。</li>
<li>最终，服务器将 HTTP 响应回送给客户端。</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4cHJvYmUuY29tL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDE2LzA4LzIyNTYyMnlpN2d6Z3p0eWV6cjQyejcucG5n.jpg" /></p>
<p>这基本上是服务器要做的全部内容了。你现在有了一个可以正常工作的 WSGI 服务器，它可以为使用任何遵循 WSGI 规范的 Web 框架（如 Django、Flask、Pyramid，还有你刚刚自己写的那个框架）构建出的 Web 应用服务。最棒的部分在于，它可以在不用更改任何服务器代码的情况下，与多个不同的 Web 框架一起工作。真不错。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzk0ODQ5Ni8yMDE2MDkvOTQ4NDk2LTIwMTYwOTA2MTIxMDI2OTczLTE3OTQyMTMwMDIuanBn.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 02:42:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Web服务精讲–搭个 Web 服务器（二）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n1eBoM.html" rel="bookmark">《Linux系统精讲》学习总结（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本次总结我将采取总结性,对比性的方式一目了然的展示出来,首先将所有的命令总结在一起,然后对比性的总结部分知识点,最后谈谈本周的学习体会. 一.Linux系统精讲常用命令 格式:命令作用 命令 :命令语法:#注释说明或者补充 例如:创建目录 mkdir:mkdir -m/p 目录名称: 创建目录 mkdir:mkdir -m/p 目录名称: 删除目录 rmdir:rmdir -m/p 目录名称: rm:  rm -r 目录名称= rmdir;  #系统会询问是否删除: rm -f 目录名称:  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/x0dzXr4.html" rel="bookmark">Web 服务编程，REST 与 SOAP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				REST 简介 在开始我们的正式讨论之前,让我们简单看一下 REST 的定义. REST(Representational State Transfer)是 Roy Fielding 提出的一个描述互联系统架构风格的名词.为什么称为 REST?Web 本质上由各种各样的资源组成,资源由 URI 唯一标识.浏览器(或者任何其它类似于浏览器的应用程序)将展示出该资源的一种表现方式,或者一种表现状态.如果用户在该页面中定向到指向其它资源的链接,则将访问该资源,并表现出它的状态.这意味着客户端应用程序随			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWyZxy3.html" rel="bookmark">读书笔记--大规模web服务开发技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总评   这本书是日本一个叫hatena的大型网站的CTO写的,通过hatena网站从小到大的演进来反应一个web系统从小到大过程中的各种系统和技术架构变迁,比较接地气. 书的内容不是很难,所以总的来说比较容易阅读,不需要特别累的啃,可想而知,不是非常深入的,更多的还是把作者的一些经验写出来,hatena这种量级的在国内应该是一个中型网站的水平,作者基本把这个量级web服务的运维的方方面面都讲了一遍,看完可以对这个这种量级网站有一个总体的了解,个人认为还是值得一读的. 逐章读书笔记: 第一章 大			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R8D674.html" rel="bookmark">nginx提供web服务和实现负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				##############nginx直接作为web服务站点###########背景:一台服务器建立两个web服务站点1)mkdir  /web1  /web2  ##建立二根个目录cd /web1vim index.htmlwww.web1.org    ##随便写东西 cd /web2vim index.html  www.web2.org    ##随便写东西和第一个不一样就行2)vim  /usr/local/nginx/conf/nginx.conf  ##添加以下参数 server			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmOOvY3.html" rel="bookmark">使用BPEL创建Web服务组合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.cnblogs.com/ahhuiyang/archive/2012/12/18/2824131.html 为简单起见,本例的Web服务组合只调用一个Web Service API.本文环境是:Eclipse Juno Release + JRE 1.7 + Tomcat 7.0.29 + BPEL + ODE,Eclipse的安装,JRE环境变量配置和Tomcat配置本文就不讲了.BPEL似乎不能运行于MyEclipse,本人在MyEclipse环境下没有成功,可能跟端口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38wQry0.html" rel="bookmark">web应用程序和web服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们在建立网站服务时,有两种不同的web开发模式: 一.web应用程序(web application):web应用程序是透过http请求来存取web服务器的网页,或执行服务端网页技术的程序,例如:ASP,ASP.NET,JSP,PHP. 二.web服务(web services):透过通讯协定SOAP或RESTful api提供资料交换和工作分享,这也是一种web应用程序,只不过是透过web服务来执行. web应用程序(web application) web应用程序简单来说就是一组网页(包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Kvr2JM.html" rel="bookmark">使用 Jersey 和 Apache Tomcat 构建 RESTful Web 服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RESTful Web 服务简单介绍 REST 在 2000 年由 Roy Fielding 在博士论文中提出,他是 HTTP 规范 1.0 和 1.1 版的首席作者之中的一个. REST 中最重要的概念是资源(resources),使用全球 ID(通常使用 URI)标识. client应用程序使用 HTTP 方法(GET/ POST/ PUT/ DELETE)操作资源或资源集.RESTful Web 服务是使用 HTTP 和 REST 原理实现的 Web 服务.通常,RESTful Web 服			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y1XBJ0.html" rel="bookmark">详解CentOS配置和管理web服务-Apache</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解CentOS配置和管理web服务-Apache 家住海边喜欢浪:zhang789.blog.51cto.com 目录 1.web介绍 2.web历史和工作原理 3.http请求流程 4.关于Apache 5.Apache服务器软件安装使用 6.符号链接和虚拟目录 7.页面重定向 8.Apache日志文件 9.Apache安全配置 10.虚拟主机 10.1.基于IP 10.2.基于域名 10.3.基于端口 web服务器配置和管理 http协议简介 http协议,全称HyperText Tran			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mob2Rw4.html" rel="bookmark">利用 Apache Synapse 模拟 Web 服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Apache Synapse 是一个简单.轻量级的高性能企业服务总线 (ESB),它是在 Apache Software Foundation 的 Apache License Version 2.0 下发布的.使用 Apache Synapse,您可以通过 HTTP.HTTPS.Java™ Message Service (JMS).简单邮件传输协议 (SMTP).邮局协议版本 3 (POP3).FTP.文件系统和许多其他传输介质筛选.转换.路由.操作和监视经过大型企业系统的 SOAP.二进制			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MV26pM.html" rel="bookmark" class="title">git stash封存分支 以及关于开发新功能的处理</a>
					<div>
						有种情况,我们要修复项目的bug时,但别的分支有修改的代码,要修复的bug可能会影响(所有分支共用一个暂存区).可以单独创建一个bug分支,用于修复和提交bug,在修改前可以先stash封存分支修改的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/gMW8WL0.html" rel="bookmark" class="title">JavaScript函数，作用域以及闭包</a>
					<div>
						JavaScript函数,作用域以及闭包 1. 函数 (1). 函数定义:函数使用function关键字定义,它可以用在函数定义表达式或者函数声明定义. a. 函数的两种定义方式: * functio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02vjz0.html" rel="bookmark" class="title">Ubuntu 14&period;04 安装配置备忘录</a>
					<div>
						完全在 Linux 下工作,大概有3年时间了. 之前都是用 Windows, 而把 Linux 装在虚拟机里,现在反过来,把 Windows 装在了虚拟机里,只是因为偶尔还要用网银的缘故. 以我这几年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0llnX0.html" rel="bookmark" class="title">criteria接口查询某字段不为&num;开头</a>
					<div>
						criteria = session.createCriteria(ClientPhone.class); criteria.add(Restrictions.sqlRestriction(&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEo7yx3.html" rel="bookmark" class="title">An Introduction to Programming in Go - v1</a>
					<div>
						Types int, uint, float32, float64, bool, string Control Structures if-else for switch Arrays, Slices ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5noX0.html" rel="bookmark" class="title">JavaWeb错误处理集锦</a>
					<div>
						一:起因 (1)自己接下来想走算法的路子,打算把十大算法和数学模型学习一下,算是给自己之前 JavaWeb 的一个总结: (2)记得Java算是第一个比较上手的语言了,更是用JavaWeb走过了很长的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoY87x3.html" rel="bookmark" class="title">python之模块配置文件ConfigParser&lpar;在python3中变化较大&rpar;</a>
					<div>
						# -*- coding: utf-8 -*- #python 27 #xiaodeng #python之模块ConfigParser(在python3中为configparser) #特别注意:py ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38w1d10.html" rel="bookmark" class="title">Unity GL 画圆</a>
					<div>
						Unity下GL没有画圆的函数,只能自己来了. 如果能帮到大家,我也很高兴. 虽然没有画圆的函数,但是能画直线,利用这一点,配合微积分什么的,就可以画出来了.反正就是花很多连在一起的直线,每条直线足够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZyzB3.html" rel="bookmark" class="title">H5  新特性之全局属性一</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html lang=&quot;en&quot;&gt;&lt;head&gt; &lt;meta charset=&quot;UTF-8&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6lXgX3.html" rel="bookmark" class="title">how to choose premium grade brown film faced plywood</a>
					<div>
						The full okoume brown film faced plywood that Longda wood manufactured are made of 1006 African Okou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azLbn3.html" rel="bookmark" class="title">RelativeLayout布局，不希望文本盖住其他组件</a>
					<div>
						简单的图先看上一看 上面使用的是RelativeLayout布局(不要问为什么不用LinearLayout,因为最右边的信箱的右上角还会有个红点,相对布局直接些) 需要实现的效果是,TextView居 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QalWN4.html" rel="bookmark" class="title">高等数学（总结9-多重积分&rpar;</a>
					<div>
						1)二重积分的性质:A) ?? B)可加性 C) D)如果f(x,y)&lt;=φ(x,y)E)M,m分别是f(x,y)的最大值和最小值: F)积分中值定理 2)二次积分公式:注意积分形状,x,y可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpnLN4.html" rel="bookmark" class="title">Android第十九期 - Sqlite离线存储教你写小米记事本</a>
					<div>
						这期说sqlite离线存储,最近app要加上离线文件下载的功能,自己也是弄了一天,总算是小有成果,要好好感谢老婆的大力支持,帮我测试什么的,都任劳任怨,现在能这样对我这样的好的人只有老婆了.分享代码给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPZo7M.html" rel="bookmark" class="title">C&num;  Repeater、webdiyer&colon;AspNetPager分页 AspNetPager分页样式</a>
					<div>
						AspNetPager分页样式:1.网易风格 2.拍拍风格 3.迅雷风格 地址:http://www.webdiyer.com/aspnetpagerdemo/applystyles/default. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdwGk0.html" rel="bookmark" class="title">打包apk并安装时，显示安装成功但是找不到安装图标</a>
					<div>
						遇到一个奇葩的Bug,就是打包安装apk,但是提示安装成功后在手机桌面上找不到安装成功,下面总结一下问题可能出现的原因: 1,首先查看配置文件的application中是否有设置icon的代码,并且查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JOKWAM.html" rel="bookmark" class="title">下标越界</a>
					<div>
						#include&lt;iostream&gt; #include&lt;string&gt; #include&lt;stddef.h&gt; using namespace std; string ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pg8nR3.html" rel="bookmark" class="title">数据存储的三种方式</a>
					<div>
						public class SpActivity extends Activity implements OnClickListener { public void onCreate(Bundle sa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQaLKM.html" rel="bookmark" class="title">vue&period;js 源代码学习笔记  ----- fillter-parse&period;js</a>
					<div>
						/* @flow */ export function parseFilters (exp: string): string { let inSingle = false let inDouble = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35paqn0.html" rel="bookmark" class="title">假设做一个循环滚动UIScrollView</a>
					<div>
						先上效果图: 首先初始化: - (void)viewDidLoad { //加入最后一张图 用于循环 int length = 4; NSMutableArray *tempArray = [NSMu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MENeQx0.html" rel="bookmark" class="title">答辩结束了</a>
					<div>
						一直想做一个交易所撮合交易系统,苦于没有时间和机会.终于到了大学最后一学期的毕业设计,我果断选了朱斐一个水题,然后申请换题改成了自己想做的撮合引擎. 毕业设计的题目就叫&lt;通用金融证券撮合交易引擎 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
